
// SyncDirDlg.cpp: archivo de implementacin
//

#include "stdafx.h"
#include "SyncDir.h"
#include "SyncDirDlg.h"
#include "afxdialogex.h"
#include "ShowPc.h"
#include <stdio.h> 
#include <stdlib.h> 
#include <time.h>
#include <WinSock.h>
#include <Windows.h>
#include <string.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define MYWM_NOTIFYICON (WM_USER+1)

// Cuadro de dilogo CAboutDlg utilizado para el comando Acerca de

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Datos del cuadro de dilogo
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // Compatibilidad con DDX/DDV

// Implementacin
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// Cuadro de dilogo de CSyncDirDlg


CSyncDirDlg::CSyncDirDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CSyncDirDlg::IDD, pParent)
	, m_iPredet(0)
	, m_bInicio(true)
	, m_iChronotrigger(0)
	, m_iChronotriggerM(0)
	, m_iChronotriggerH(0)
	, m_sChronotrigger(_T(""))
	, sEstado(_T(""))
	, m_iBotonConectarDesconectar(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSyncDirDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_STATIC_ESTADO, m_sEstado);
	DDV_MaxChars(pDX, m_sEstado, 65);
	DDX_Text(pDX, IDC_STATIC_DIR, m_sDirParent);
	DDV_MaxChars(pDX, m_sDirParent, 250);
	DDX_Control(pDX, IDC_TAB3, m_cTab);
	DDX_Control(pDX, IDOK, m_cBotonConectarDesconectar);
}

BEGIN_MESSAGE_MAP(CSyncDirDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, &CSyncDirDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDOpciones, &CSyncDirDlg::OnBnClickedOpciones)
	ON_BN_CLICKED(IDCANCEL, &CSyncDirDlg::OnBnClickedCancel)
	ON_WM_MOVE()
	ON_WM_SHOWWINDOW()
	ON_WM_TIMER()
	ON_MESSAGE(MYWM_NOTIFYICON,onTrayNotify)
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_COMMAND(ID_MENU_RESTAURAR, &CSyncDirDlg::OnMenuRestaurar)
	ON_COMMAND(ID_MENU_SINCRONIZAR, &CSyncDirDlg::OnMenuSincronizar)
	ON_COMMAND(ID_MENU_OPCIONES, &CSyncDirDlg::OnMenuOpciones)
	ON_COMMAND(ID_MENU_CERRAR, &CSyncDirDlg::OnMenuCerrar)
END_MESSAGE_MAP()


// Controladores de mensaje de CSyncDirDlg

BOOL CSyncDirDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Agregar el elemento de men "Acerca de..." al men del sistema.

	// IDM_ABOUTBOX debe estar en el intervalo de comandos del sistema.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Establecer el icono para este cuadro de dilogo. El marco de trabajo realiza esta operacin
	//  automticamente cuando la ventana principal de la aplicacin no es un cuadro de dilogo
	SetIcon(m_hIcon, TRUE);			// Establecer icono grande
	SetIcon(m_hIcon, FALSE);		// Establecer icono pequeo
	
	// TODO: agregar aqu inicializacin adicional
	
	// Icon Tray ///////////////////////////////////////////
	CString sTip(_T("SyncDir 1.0.1A")); // <-- Cambiar luego a CString para monstrar el tambin el estado en varias lneas por enlace (incluir '\n' para ellas.).
	tnd.cbSize = sizeof(NOTIFYICONDATA);
	tnd.hWnd = this->GetSafeHwnd();
	tnd.uID = IDR_MAINFRAME;
	//ICON RESOURCE ID
	tnd.uFlags = NIF_MESSAGE|NIF_ICON;
	tnd.uCallbackMessage = MYWM_NOTIFYICON;
	tnd.uFlags = NIF_MESSAGE|NIF_ICON|NIF_TIP; 
	tnd.hIcon = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE (IDR_MAINFRAME));
	//ICON RESOURCE ID
	lstrcpyn(tnd.szTip, (LPCTSTR)sTip, sizeof(tnd.szTip));
	DWORD dwMessage = NIM_ADD;
	Shell_NotifyIcon(dwMessage, &tnd);    
  	m_TrayMenu.LoadMenu(IDR_MENU1);
	//MENU RESOURCE ID. 
	////////////////////////////////////////////////////////

	// inicializacin de variables de configuracin.
	m_bInit = false; // para tomar los valores de posicin de la ventana asignado por Windows. (para configurar los Tabs)
	for (int i = 0 ; i < 10 ; i++) m_tTab[i]=NULL;
	sEstado = _T("...Inactivo...");
	m_sEstado = sEstado;	
	m_sDirParent = _T("[...No configurado...]");
	m_dOpcionesDlg = new COpcionesDlg; // inicia instancia de la clase COpcionesDlg.
	m_dOpcionesDlg->CargaConf(0); // carga archivo predeterminado.
	m_sDirParent = m_dOpcionesDlg->m_sSyncDir; // copia el nombre del directorio a sincronizar al dialogo principal.
	m_iBotonConectarDesconectar = 0;
	
	UpdateTab(m_dOpcionesDlg->m_iPCs); // actualiza los Tabs.
		
	m_bInicio = false;
	UpdateData(false);
	// modo silencioso
	if (m_iPredet == 1)
	{
		// minimizar si ha cargado correctamente el archivo de configuracin.
	}
	return TRUE;  // Devuelve TRUE  a menos que establezca el foco en un control
}


// Funcin de actualizacin del panel de muestra de estado de las conexiones.
int CSyncDirDlg::UpdateTab(int n)
{
	
	int i, i3;
	char m_ctab[5];
	CString s;
	
	i3 = m_cTab.GetItemCount();
	for ( i = 0; i < i3 ; i++)
	{
		delete m_tTab[i];
	}
	m_cTab.DeleteAllItems();
	m_cTab.DelTabPane();
	for ( i = 0 ; i < n ; i++ )
	{
		m_tTab[i] = new CShowPc(this);
		
		switch (i)
			{
		case 0:
			m_tTab[0]->m_sPC_IP = m_dOpcionesDlg->m_sEnlacePC1; //actualiza variable
			m_tTab[0]->m_iPC_Puerto = m_dOpcionesDlg->m_iPuertoPC1;

			break;
		case 1:
			m_tTab[1]->m_sPC_IP = m_dOpcionesDlg->m_sEnlacePC2; //actualiza variable
			m_tTab[1]->m_iPC_Puerto = m_dOpcionesDlg->m_iPuertoPC2;
			break;
		case 2:
			m_tTab[2]->m_sPC_IP = m_dOpcionesDlg->m_sEnlacePC3; //actualiza variable
			m_tTab[2]->m_iPC_Puerto = m_dOpcionesDlg->m_iPuertoPC3;
			break;
		case 3:
			m_tTab[3]->m_sPC_IP = m_dOpcionesDlg->m_sEnlacePC4; //actualiza variable
			m_tTab[3]->m_iPC_Puerto = m_dOpcionesDlg->m_iPuertoPC4;
			break;
		case 4:
			m_tTab[4]->m_sPC_IP = m_dOpcionesDlg->m_sEnlacePC5; //actualiza variable
			m_tTab[4]->m_iPC_Puerto = m_dOpcionesDlg->m_iPuertoPC5;
			break;
		case 5:
			m_tTab[5]->m_sPC_IP = m_dOpcionesDlg->m_sEnlacePC6; //actualiza variable
			m_tTab[5]->m_iPC_Puerto = m_dOpcionesDlg->m_iPuertoPC6;
			break;
		case 6:
			m_tTab[6]->m_sPC_IP = m_dOpcionesDlg->m_sEnlacePC7; //actualiza variable
			m_tTab[6]->m_iPC_Puerto = m_dOpcionesDlg->m_iPuertoPC7;
			break;
		case 7:
			m_tTab[7]->m_sPC_IP = m_dOpcionesDlg->m_sEnlacePC8; //actualiza variable
			m_tTab[7]->m_iPC_Puerto = m_dOpcionesDlg->m_iPuertoPC8;
			break;
		case 8:
			m_tTab[8]->m_sPC_IP = m_dOpcionesDlg->m_sEnlacePC9; //actualiza variable
			m_tTab[8]->m_iPC_Puerto = m_dOpcionesDlg->m_iPuertoPC9;
			break;
		case 9:
			m_tTab[9]->m_sPC_IP = m_dOpcionesDlg->m_sEnlacePC10; //actualiza variable
			m_tTab[9]->m_iPC_Puerto = m_dOpcionesDlg->m_iPuertoPC10;
			break;
		}
		m_tTab[i]->Create(IDD_FORMVIEW_PC, m_cTab.GetWindow(IDD_FORMVIEW_PC));
		sprintf_s(m_ctab, "PC%.2d", i+1);
		CString m_stab = CString(m_ctab);
		m_cTab.xref = 12;
		m_cTab.yref = 95;
		m_cTab.AddTabPane(m_stab, m_tTab[i]);
	}
	if (!m_bInicio)
	{
		CRect pos;
		this->GetClientRect(pos);
		this->ShowWindow(SW_HIDE);
		this->SetWindowPos(this, pos.left,pos.top,pos.right,pos.bottom,0);
		this->ShowWindow(SW_SHOW);
	}
	UpdateData(false);
	return 0;
}

void CSyncDirDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// Si agrega un botn Minimizar al cuadro de dilogo, necesitar el siguiente cdigo
//  para dibujar el icono. Para aplicaciones MFC que utilicen el modelo de documentos y vistas,
//  esta operacin la realiza automticamente el marco de trabajo.

void CSyncDirDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Contexto de dispositivo para dibujo

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Centrar icono en el rectngulo de cliente
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Dibujar el icono
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// El sistema llama a esta funcin para obtener el cursor que se muestra mientras el usuario arrastra
//  la ventana minimizada.
HCURSOR CSyncDirDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// Iniciar sincronizacin.
void CSyncDirDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	m_iBotonConectarDesconectar++;
	
	if (m_iBotonConectarDesconectar == 1)
	{
		GetDlgItem(IDOpciones)->EnableWindow(FALSE);
		m_cBotonConectarDesconectar.SetWindowTextW(_T("&Detener"));
		SetCTimer();
		sEstado = _T("...Activo...");
		UpdateData(false);
		m_DirChangeHandler.file.m_sDir = m_dOpcionesDlg->m_sSyncDir;

		//////// Etapas faltantes.
		// Ejecucin de las conexiones y verificacin de archivos

		// Se hizo un hash? --> Lanza proceso de hash (Sha2) (CFilesManager.cpp --> CFileTools.cpp)
	
		// Cambi algo? --> Hace lista de solicitudes de archivos.

		// Lanza Monitor de cambios en directorio monitorizado.
		m_DirWatcher.WatchDirectory( m_dOpcionesDlg->m_sSyncDir,
							FILE_NOTIFY_CHANGE_FILE_NAME	|
							FILE_NOTIFY_CHANGE_DIR_NAME		|
							FILE_NOTIFY_CHANGE_SIZE			|
							FILE_NOTIFY_CHANGE_CREATION,
							&m_DirChangeHandler,
							TRUE, //<-- ver subdirectorios? 
							NULL, //<-- Filtro para incluir
							_T(".SyncDir.Temp"));//<-- Filtro para excluir

		// -->Lanza proceso paralelo por espera de conexiones, el cual lanza hasta 10 procesos para recepcin de solicitudes por archivos. (CInSolArch.cpp)
		IniciaServidor();

		// -->Lanza proceso paralelo para la conexin a otros servidores para solicitar lista de archivos modificados,
		IniciaCliente();

		// Listo. --> Queda a la espera de cambios en los archivos

		// Cierre (OnDestroy();) --> evento de cierre a los subprocesos y espera a que se cierren y sale del proceso principal.

		// (Ordenar cdigo y Comentarios)

		//CDialogEx::OnOK();
	} else 
	{
		GetDlgItem(IDOpciones)->EnableWindow(TRUE);
		m_cBotonConectarDesconectar.SetWindowTextW(_T("&Iniciar"));
		sEstado = _T("...Inactivo...");
		m_iBotonConectarDesconectar = 0;
		KillCTimer();
		UpdateData(false);
	}
}

void CSyncDirDlg::IniciaCliente(void)
{
	m_pWinThreadClient = AfxBeginThread(ThreadClientFunc, this, THREAD_PRIORITY_IDLE);
}

void CSyncDirDlg::IniciaServidor(void)
{
	m_pWinThreadClient = AfxBeginThread(ThreadServerFunc, this, THREAD_PRIORITY_IDLE);
}

// Inicia ventana de opciones.
void CSyncDirDlg::OnBnClickedOpciones()
{
	// TODO: Add your control notification handler code here
	if (m_dOpcionesDlg->DoModal() == IDOK)
	{
		// redibuja los cambios
		// Tab
		UpdateTab(m_dOpcionesDlg->m_iPCs);

		// Cambios generales.
		UpdateData(false);
	}
}


void CSyncDirDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	CDialogEx::OnCancel();
}


void CSyncDirDlg::OnMove(int x, int y)
{
	CDialogEx::OnMove(x, y);

	// TODO: Add your message handler code here
	m_cTab.OnMove(x,y);

}

void CSyncDirDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialogEx::OnShowWindow(bShow, nStatus);

	// TODO: Add your message handler code here
	m_cTab.SetDefaultPane(0);
}

void CSyncDirDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	switch (nIDEvent)
	{
		case ID_CTIMER:
			break;
		case ID_CHRONOTRIGGER:
			m_iChronotrigger++;
			if (m_iChronotrigger > 59)
			{
				m_iChronotrigger = 0;
				m_iChronotriggerM++;
			}
			if (m_iChronotriggerM > 59)
			{
				m_iChronotriggerM = 0;
				m_iChronotriggerH++;
			}
			if (m_iChronotriggerH > 24)
			{
				m_iChronotriggerH = 0;
			}
			m_sChronotrigger.Format(_T(" %.2d : %.2d : %.2d"), m_iChronotriggerH, m_iChronotriggerM, m_iChronotrigger);
			m_sEstado.SetString(sEstado + m_sChronotrigger);
			UpdateData(false);
			break;
	}

	CDialogEx::OnTimer(nIDEvent);
}

// Habilita el timer.
int CSyncDirDlg::SetCTimer(void)
{
	SetTimer(ID_CHRONOTRIGGER, 1000, NULL);
	return 0;
}

// Elimina el Timer.
int CSyncDirDlg::KillCTimer(void)
{
	KillTimer(ID_CHRONOTRIGGER);
	return 0;
}

LRESULT CSyncDirDlg::onTrayNotify(WPARAM wParam,LPARAM lParam)
  {
    UINT uMsg = (UINT) lParam; 
    switch (uMsg ) 
    { 
    case WM_LBUTTONDBLCLK:
    this->ShowWindow(SW_SHOW);
	this->ShowWindow(SW_RESTORE);
    break;
    case WM_RBUTTONUP:
    CPoint pt;    
    GetCursorPos(&pt);
    m_TrayMenu.GetSubMenu(0)->TrackPopupMenu(TPM_RIGHTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,pt.x,pt.y,this);
    break;
    } 
    return TRUE;
}

void CSyncDirDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	// TODO: Add your message handler code here
	Shell_NotifyIcon(NIM_DELETE,&tnd);


	// colocar destructores de objetos y cerrar las conexiones, eventos a los subprocesos.
}

void CSyncDirDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialogEx::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
		if (nType == SIZE_MINIMIZED)
	{
		ShowWindow(SW_HIDE);
	} else if ((nType == SIZE_RESTORED || nType == SIZE_MAXIMIZED) && (!m_bInicio))
	{
		ShowWindow(SW_SHOW);
	}
}

void CSyncDirDlg::OnMenuRestaurar()
{
	// TODO: Add your command handler code here
	ShowWindow(SW_SHOW);
	ShowWindow(SW_RESTORE);
}

void CSyncDirDlg::OnMenuSincronizar()
{
	// TODO: Add your command handler code here
	OnBnClickedOk();
}

void CSyncDirDlg::OnMenuOpciones()
{
	// TODO: Add your command handler code here
	OnBnClickedOpciones();
}

void CSyncDirDlg::OnMenuCerrar()
{
	// TODO: Add your command handler code here
	OnBnClickedCancel();
}

/* statix */ UINT CSyncDirDlg::ThreadClientFunc( LPVOID pParam )
{
	CSyncDirDlg* p = (CSyncDirDlg*) pParam; // Enlace a los recursos

	return NULL;
}

/* statix */ UINT CSyncDirDlg::ThreadServerFunc( LPVOID pParam )
{
	CSyncDirDlg* p = (CSyncDirDlg*) pParam; // Enlace a los recursos

	return NULL;
}
